pt pickedPoint = P();
int vc=32, kc=8, kc2, kc2LIN;           // vertex and keyframe counts
int k=0;                     // current key frame
Polyloop [] CP= new Polyloop [kc];  // control polyloops
Polyloop [] QCP= new Polyloop [kc*32];  // ANOTHER control polyloops...*2^5. Makes it big so that it can contain all 256 Polyloops.
Polyloop [] QCPtemp= new Polyloop [kc*32];  // ANOTHER control polyloops...*2^5. Makes it big so that it can contain all 256 Polyloops.
//Polyloop [] QCP_LIN= new Polyloop [kc*32];  // ANOTHER control polyloops...*2^5. Makes it big so that it can contain all 256 Polyloops.
//Polyloop [] QCPtemp_LIN= new Polyloop [kc*32];  // ANOTHER control polyloops...*2^5. Makes it big so that it can contain all 256 Polyloops.
Polyloop C= new Polyloop();  // used to cut and paste
Polyloop P= new Polyloop();  // reference for editing
Polyloop Q= new Polyloop();  // reference for editing
Polyloop D= new Polyloop();  // used to capture the curve drawn by the user
int style=0;                 // animation style: 0=stroboscopic, 1=linear, 2=...
boolean showFrames=false;        // toggle show all frames
boolean showKeys=false;          // toggle show all keys
boolean animate=false;          // toggle show all keys
boolean showMouseProjection=false;          // toggle show mouse projection
boolean sketching=false;     // toggle indicating that the user is sketching the selected curve
boolean showVertices=true;   // show control vertices
boolean showEkey=true;    // show edited curve
float t=0;                   // current time for animation
boolean canStart=true;
boolean inLoop=true;
boolean resetColorAmount=true;

void myInit() {
  for(int i=0; i<kc; i++) CP[i]=new Polyloop(); myReset(); mySelected(0); myLoad();//ADDED the myLoad() show that sword would start up
  for(int i=0; i<kc*32; i++) QCP[i]=new Polyloop();
  for(int i=0; i<kc*32; i++) QCPtemp[i]=new Polyloop();
  for(int i=0; i<kc*32; i++) QCP[i].vn=vc;    
  for(int i=0; i<kc*32; i++) QCPtemp[i].vn=vc;  
//  for(int i=0; i<kc*32; i++) QCP_LIN[i]=new Polyloop();
//  for(int i=0; i<kc*32; i++) QCPtemp_LIN[i]=new Polyloop();  
//  for(int i=0; i<kc*32; i++) QCP_LIN[i].vn=vc;    
//  for(int i=0; i<kc*32; i++) QCPtemp_LIN[i].vn=vc;      
};

void myReset() {for(int i=0; i<kc; i++) CP[i].reset(vc);};
void mySave() {for(int i=0; i<kc; i++) CP[i].savePts(i);}; 
void myLoad() {for(int i=0; i<kc; i++) CP[i].loadPts(i);}; 
void myDenoise() {P.smoothen(5);}
void mySample() {P.resample(32);}
void myRefine() {P.refine(0,0);}
void myCopy() {C.setTo(CP[k]);}
void myPaste() {CP[k].setTo(C);}
   
void mySelected(int n) {k=n; P=CP[k];}     // user selects curve by typing its number n: select curve
void myStartAcquisition() {D.empty(); D.appendPt(Mouse()); sketching=true; }  // start acquisition processd
void myEndAcquisition() {if(sketching) {D.smoothen(5); for(int i=0; i<4; i++); D.refine(0,0); D.smoothen(10); D.resample(vc); P.setTo(D); sketching=false;}; }      // finish acquisition process
void myMousePressed() {
   if (Mouse().isInWindow()&&!keyPressed&&!sketching) pickedPoint=P.pickPoint(); 
   else if (Mouse().isInWindow()&&keyPressed&&(key=='d')) myStartAcquisition(); 
   } 
void myMouseReleased() {pickedPoint=null; myEndAcquisition();}
void myScale() {P.scaleWithMouse();}  
void myTranslate() {P.translateWithMouse();}
void myRotate() {P.rotateWithMouse();}

void myActions() { // actions to be executed at each frame
    scribe("Derek Tatum's Interpolation/Animation Demo for Jarek Rossignac's P04");               
    scribe("Control curve "+k+" is selected. Style "+str(style),1);               
   if(animate){translate(0,20);scribe("Animating",2);translate(0,-20);}   
   if((mousePressed)&&!keyPressed) {if(pickedPoint!=null) pickedPoint.trackMouse(); };
   if((mousePressed)&&keyPressed) {if(key=='m') myTranslate(); if(key=='t') myRotate(); if(key=='z') myScale(); if(key=='d') D.extendToMouse();};
   if(showFrames) {       
       if(style==1) {// linear interpolation                                           // **P04
         scribe("Linear Interpolation",2);
         doEverythingLinear();
         cS.reset(kc2LIN);//RESETS the amount of colors to be used..e.g. there are kc2 number of colors that can be used by "cs.next"
         for(int i=0; i<kc2LIN; i++) {//65 is when it starts..hmm..129 is the next one, then 193
           stroke(cS.next());
           QCP[i].drawSmooth(0,5);           
           println("Linear frame ="+i);
         }
     }//LINEAR INTERPOLATE
       else if(style==2) { // four-point interpolation                                           // **P04
         scribe("Four-point Interpolation",2);
         doEverything();
         cS.reset(kc2);//RESETS the amount of colors to be used..e.g. there are kc2 number of colors that can be used by "cs.next"
         for(int i=0; i<kc2; i++) {//65 is when it starts..hmm..129 is the next one, then 193
           stroke(cS.next());
           QCP[i].drawSmooth(0,5);         
           println("4point frame ="+i);  
           //if(style!=2)break;           
       }
     }//FOUR POINT
       else if(style==3) {;}  // smoother interpolation                                            // **P04
       else {
         if(style==0)scribe("Original Keyframes",2);         
         else scribe("??? Interpolation",2);
         cS.reset(kc); 
         for(int i=0; i<kc; i++) {
           stroke(cS.next()); 
           CP[i].drawSmooth(0,5);
           println("strobe guys "+i);           
         }; 
           
       };  // Default style: (stroboscopic) shows only key-frames
   }; // end if(showFrames)
   if(showKeys) {stroke(metal); noFill(); for(int i=0; i<kc; i++) CP[i].drawSmooth(0,5); fill(metal); for(int i=0; i<kc; i++) CP[i].rP(0).showLabel(i); noFill();}; // show all keys
   if(sketching) {stroke(dred,50); noFill(); P.drawSmooth(0,5); fill(red,50); P.rP(0).show(4); fill(yellow,50); P.rP(1).show(3); stroke(red); noFill(); D.drawOpen(); noStroke();}
   if(showEkey) {stroke(red);  if(!sketching) fill(yellow); P.drawSmooth(0,5); fill(white); if(showVertices) P.showVertices(); fill(red); P.rP(0).show(4); fill(yellow); P.rP(1).show(3); };
   if(showMouseProjection) P.showMouseProjection(0,5);  // show closest point on P to mouse green if mouse is inside and red otherwise
   
   if(animate) {t++; if (t>=kc*32){ t=0;} //was t>=kc*32
     if(resetColorAmount){cS.reset(kc*32);resetColorAmount=false;}
     if(t==0)cS.first();//Is redundant, but makes sure the colors always reset properly
     fill(cS.next());stroke(color(121*cS.c/cS.nc,121,121));//Doing it this way allows the cS to match the t, which works out b/c both are 256
     if(style==1) {         
     println(t);       
       if(canStart){canStart=false;doEverythingLinear();}
       QCP[int(t)].drawSmooth(0,5);  
       //picture();          
     } // linear motion                                                    // **P04 
     else if(style==2) {      
       println(t);       
       if(canStart){canStart=false;doEverything();}        
       QCP[int(t)].drawSmooth(0,5);
       //picture();                
     } // Four-point style animation
     else if(style==3) {}  // smoother motion                                            // **P04
     else {stroke(red);fill(yellow); CP[int(t/32)].drawSmooth(0,5);};  // Default style: jumps from frame to frame (stroboscopic)
     };
   };

int my_prev(int p){return(p+kc2-1)%kc2;}
int my_next(int p){return(p+1)%kc2;}

int my_prevLIN(int p){return(p+kc2LIN-1)%kc2LIN;}
int my_nextLIN(int p){return(p+1)%kc2LIN;}

void doEverythingLinear() {//linear interpolation
  kc2LIN=kc;
  for (int i=0; i<kc; i++){QCPtemp[i].setTo(CP[i]);QCP[2*i].setTo(CP[i]);}
  for (int iter=0; iter<5; iter++) {
    for (int j=0; j<vc; j++){
      for (int i=0; i<kc2LIN; i++) QCP[2*i+1].P[j].setTo((QCPtemp[i].P[j].x + QCPtemp[my_nextLIN(i)].P[j].x)*.5 ,
                                                             (QCPtemp[i].P[j].y + QCPtemp[my_nextLIN(i)].P[j].y)*.5);}
    kc2LIN = kc2LIN*2;
    for (int i=0; i<kc2LIN; i++){ QCPtemp[i].setTo(QCP[i]); println(i);}
    if(iter!=4)for (int i=0; i<kc2LIN; i++) QCP[2*i].setTo(QCPtemp[i]);    
}//END iter
}//END everything

void doEverything() {
  kc2=kc;
  for (int i=0; i<kc; i++){QCPtemp[i].setTo(CP[i]);QCP[2*i].setTo(CP[i]);}
  for (int iter=0; iter<5; iter++) {
    for (int j=0; j<vc; j++){
      for (int i=0; i<kc2; i++) QCP[2*i+1].P[j].setTo(-0.0625*QCPtemp[my_prev(i)].P[j].x +  0.5625*QCPtemp[i].P[j].x + 
                                                       0.5625*QCPtemp[my_next(i)].P[j].x + -0.0625*QCPtemp[my_next(my_next(i))].P[j].x  ,//did four point on x's, now for y's..
                                                      -0.0625*QCPtemp[my_prev(i)].P[j].y +  0.5625*QCPtemp[i].P[j].y + 
                                                       0.5625*QCPtemp[my_next(i)].P[j].y + -0.0625*QCPtemp[my_next(my_next(i))].P[j].y);}
    kc2 = kc2*2;
    for (int i=0; i<kc2; i++){ QCPtemp[i].setTo(QCP[i]); println(i);}
    if(iter!=4)for (int i=0; i<kc2; i++) QCP[2*i].setTo(QCPtemp[i]);    
  }//END iter
}//END everything

/*
void doEverythingOld1() {
  kc2=kc;
  for (int i=0; i<kc; i++) QCP[2*i].setTo(CP[i]);
    for (int j=0; j<vc; j++)
    {
      for (int i=0; i<kc2; i++) QCP[2*i+1].P[j].setTo(-0.0625*CP[my_prev(i)].P[j].x + 0.5625*CP[i].P[j].x + 0.5625*CP[my_next(i)].P[j].x + -0.0625*CP[my_next(my_next(i))].P[j].x,
                                                          -0.0625*CP[my_prev(i)].P[j].y + 0.5625*CP[i].P[j].y + 0.5625*CP[my_next(i)].P[j].y + -0.0625*CP[my_next(my_next(i))].P[j].y);
    }
    //kc2 = kc2*2;
//    for (int i=0; i<kc2; i++){ QCP[i].setTo(QCPtemp[i]); println(i);}



}

void doEverythingOld2() {
  kc2=kc;
  for (int i=0; i<kc; i++) QCP[2*i].setTo(CP[i]);
  for (int iter=0; iter<5; iter++) {

    for (int j=0; j<vc; j++)
    {
      for (int i=0; i<kc2; i++) QCPtemp[2*i+1].P[j].setTo(-0.0625*QCP[my_prev(i)].P[j].x + 0.5625*QCP[i].P[j].x + 0.5625*QCP[my_next(i)].P[j].x + -0.0625*QCP[my_next(my_next(i))].P[j].x,
                                                          -0.0625*QCP[my_prev(i)].P[j].y + 0.5625*QCP[i].P[j].y + 0.5625*QCP[my_next(i)].P[j].y + -0.0625*QCP[my_next(my_next(i))].P[j].y);
    }
    kc2 = kc2*2;
    for (int i=0; i<kc2; i++){ QCP[i].setTo(QCPtemp[i]); println(i);}
  }//END iter
}//END everthing


void doEverythingOld3() {
  kc2=kc;
  for (int i=0; i<kc; i++) QCP[2*i].setTo(CP[i]);
//  for (int iter=0; iter<5; iter++) {
    for (int j=0; j<vc; j++)
    {
      for (int i=0; i<kc2; i++) QCP[2*i+1].P[j].setTo(-0.0625*CP[my_prev(i)].P[j].x + 0.5625*CP[i].P[j].x + 0.5625*CP[my_next(i)].P[j].x + -0.0625*CP[my_next(my_next(i))].P[j].x,
                                                          -0.0625*CP[my_prev(i)].P[j].y + 0.5625*CP[i].P[j].y + 0.5625*CP[my_next(i)].P[j].y + -0.0625*CP[my_next(my_next(i))].P[j].y);
    }
    kc2 = kc2*2;
    for (int i=0; i<kc2; i++){ QCPtemp[2*i].setTo(QCP[i]); println(i);}
    
    for (int j=0; j<vc; j++)
    {
      for (int i=0; i<16; i++) QCPtemp[(2*i)+1].P[j].setTo(-0.0625*QCP[my_prev(i)].P[j].x + 0.5625*QCP[i].P[j].x + 0.5625*QCP[my_next(i)].P[j].x + -0.0625*QCP[my_next(my_next(i))].P[j].x,
                                                           -0.0625*QCP[my_prev(i)].P[j].y + 0.5625*QCP[i].P[j].y + 0.5625*QCP[my_next(i)].P[j].y + -0.0625*QCP[my_next(my_next(i))].P[j].y);
    }
    for (int i=0; i<32; i++){ QCP[i].setTo(QCPtemp[i]); println(i);}    
 // }//END iter
}//END everthing
*/
